<?php
if ( ! defined('ABSPATH') ) {
    die('Please do not load this file directly!');
}
function cth_register_cpt_Cth_Speakers() {
    
    $labels = array( 
        'name' => __( 'Speakers', 'cth-gather-plugins' ),
        'singular_name' => __( 'Speaker', 'cth-gather-plugins' ),
        'add_new' => __( 'Add New Speaker', 'cth-gather-plugins' ),
        'add_new_item' => __( 'Add New Speaker', 'cth-gather-plugins' ),
        'edit_item' => __( 'Edit Speaker', 'cth-gather-plugins' ),
        'new_item' => __( 'New Speaker', 'cth-gather-plugins' ),
        'view_item' => __( 'View Speaker', 'cth-gather-plugins' ),
        'search_items' => __( 'Search Speakers', 'cth-gather-plugins' ),
        'not_found' => __( 'No Speakers found', 'cth-gather-plugins' ),
        'not_found_in_trash' => __( 'No Speakers found in Trash', 'cth-gather-plugins' ),
        'parent_item_colon' => __( 'Parent Speaker:', 'cth-gather-plugins' ),
        'menu_name' => __( 'Gather Event Speakers', 'cth-gather-plugins' ),
    );

    $args = array( 
        'labels' => $labels,
        'hierarchical' => true,
        'description' => 'List Speakers',
        'supports' => array( 'title', 'editor', 'thumbnail'/*,'comments', 'post-formats'*/),
        //'taxonomies' => array('cth_speaker_cat'),
        'public' => true,
        'show_ui' => true,
        'show_in_menu' => true,
        'menu_position' => 20,
        'menu_icon'   => 'dashicons-groups',
        //'menu_icon' => plugin_dir_url( __FILE__ ) .'assets/admin_ico_portfolio.png', 
        'show_in_nav_menus' => true,
        'publicly_queryable' => true,
        'exclude_from_search' => false,
        'has_archive' => true,
        'query_var' => true,
        'can_export' => true,
        //'rewrite' => true,
        'rewrite' => array(
                            'slug'=>__('cth_speaker','cth-gather-plugins'),
                            'with_front' => false
                    ),
        'capability_type' => 'post'
    );

    register_post_type( 'cth_speaker', $args );
}

//Register Schedule 
add_action( 'init', 'cth_register_cpt_Cth_Speakers' );

function cth_gather_plugins_speakers_add_meta_box() {

    $screens = array( 'cth_speaker');

    foreach ( $screens as $screen ) {

        add_meta_box(
            'cth_speaker_job',
            __( 'Details', 'cth-gather-plugins' ),
            'cth_gather_plugins_speakers_meta_box_job_callback',
            $screen,
            'normal',
            'core'
            //,'normal', //('normal', 'advanced', or 'side')
            //'core'//('high', 'core', 'default' or 'low') 
        );
        add_meta_box(
            'cth_speaker_single_layout',
            __( 'Single Sidebar', 'cth-gather-plugins' ),
            'cth_gather_plugins_speakers_meta_box_single_layout_callback',
            $screen,
            'normal',
            'core'
            //,'normal', //('normal', 'advanced', or 'side')
            //'core'//('high', 'core', 'default' or 'low') 
        );

        
    }

    
}
add_action( 'add_meta_boxes', 'cth_gather_plugins_speakers_add_meta_box' );
function cth_gather_plugins_speakers_meta_box_job_callback( $post ) {
    // Add a nonce field so we can check for it later.
    wp_nonce_field( 'cth_gather_plugins_save_meta_box_data', 'cth_gather_plugins_meta_box_nonce' );

    /*
     * Use get_post_meta() to retrieve an existing value
     * from the database and use the value for the form.
     */
    $value = get_post_meta( $post->ID, 'cth_speaker_job', true );
    $country_value = get_post_meta( $post->ID, 'cth_speaker_country', true );
    
    echo '<table class="form-table"><tbody>';

    echo '<tr><th style="width:20%">';
        echo '<label>';
        _e( 'Speaker Job: ', 'cth-gather-plugins' );
        echo '</label> ';
    echo '</th>';
    echo '<td>';
        echo '<input type="text" id="cth_speaker_job" name="cth_speaker_job" value="' . esc_attr( $value ) . '" size="25" />';
    echo '</td></tr>';

    echo '<tr><th style="width:20%">';
        echo '<label>';
        _e( 'Speaker Country: ', 'cth-gather-plugins' );
        echo '</label> ';
    echo '</th>';
    echo '<td>';
        echo '<input type="text" id="cth_speaker_country" name="cth_speaker_country" value="' . esc_attr( $country_value ) . '" size="25" />';
    echo '</td></tr>';

    echo '</tbody></table>';  
}

function cth_gather_plugins_speakers_meta_box_single_layout_callback( $post ) {

    // default reservation status
    $defauls = array(
        'fullwidth'=>__('No Sidebar','cth-gather-plugins'),
        'right_sidebar'=>__('Right Sidebar','cth-gather-plugins'), 
        'left_sidebar'=>__('Left Sidebar','cth-gather-plugins'), 
        
    );

    // Add a nonce field so we can check for it later.
    wp_nonce_field( 'cth_gather_plugins_save_meta_box_data', 'cth_gather_plugins_meta_box_nonce' );

    /*
     * Use get_post_meta() to retrieve an existing value
     * from the database and use the value for the form.
     */
    $value = get_post_meta( $post->ID, 'cth_speaker_single_layout', true );

    echo '<table class="form-table"><tbody><tr>';
    echo '<th style="width:20%">';
        echo '<label for="cth_speaker_single_layout">';
        _e( 'Sidebar', 'cth-gather-plugins' );
        echo '</label> ';
    echo '</th>';
    echo '<td>';
        echo '<select id="cth_speaker_single_layout" name="cth_speaker_single_layout">';
        foreach ($defauls as $key => $val) {
            $selected = '';
            if($value === $key){
                $selected = ' selected="selected"';
            }
            echo '<option value="'.$key.'"'.$selected.'>'.$val.'</option>';
        }
        echo '</select>';
    echo '</td></tr>';
    echo '</tbody></table>';  
}

function cth_gather_plugins_speakers_save_meta_box_datas( $post_id ) {

    /*
     * We need to verify this came from our screen and with proper authorization,
     * because the save_post action can be triggered at other times.
     */

    // Check if our nonce is set.
    if ( ! isset( $_POST['cth_gather_plugins_meta_box_nonce'] ) ) {
        return;
    }

    // Verify that the nonce is valid.
    if ( ! wp_verify_nonce( $_POST['cth_gather_plugins_meta_box_nonce'], 'cth_gather_plugins_save_meta_box_data' ) ) {
        return;
    }

    // If this is an autosave, our form has not been submitted, so we don't want to do anything.
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
        return;
    }

    // Check the user's permissions.
    if ( isset( $_POST['post_type'] ) && 'cth_speaker' == $_POST['post_type'] ) {

        if ( ! current_user_can( 'edit_page', $post_id ) ) {
            return;
        }

    } else {

        if ( ! current_user_can( 'edit_post', $post_id ) ) {
            return;
        }
    }




    if(isset($_POST['cth_speaker_job'])){
        update_post_meta( $post_id, 'cth_speaker_job', sanitize_text_field( $_POST['cth_speaker_job'] ) );
    }
    if(isset($_POST['cth_speaker_country'])){
        update_post_meta( $post_id, 'cth_speaker_country', sanitize_text_field( $_POST['cth_speaker_country'] ) );
    }
    if(isset($_POST['cth_speaker_single_layout'])){
        update_post_meta( $post_id, 'cth_speaker_single_layout', sanitize_text_field( $_POST['cth_speaker_single_layout'] ) );
    }
    
    
    
}
add_action( 'save_post', 'cth_gather_plugins_speakers_save_meta_box_datas' );

if(!function_exists('cth_gather_plugins_speakers_columns_head')){
    function cth_gather_plugins_speakers_columns_head($defaults) {
        unset($defaults['date']);
        // unset($defaults['title']);
        $defaults['cth_speaker_job']             = __('Speaker Job','cth-gather-plugins');
        $defaults['date']             = __('Date','cth-gather-plugins');
        $defaults['cth_speaker_id']             = __('ID','cth-gather-plugins');
        

        return $defaults;
    }
}

if(!function_exists('cth_gather_plugins_speakers_columns_content')){
    function cth_gather_plugins_speakers_columns_content($column_name, $post_ID) {
        if ($column_name == 'cth_speaker_id') {
            echo '<strong>'.esc_attr($post_ID ).'</strong>';
            
        }
        if ($column_name == 'cth_speaker_job') {
            echo '<strong>'.get_post_meta( $post_ID, 'cth_speaker_job', true ).'</strong>';
            
        }
        
    }
}


add_filter('manage_cth_speaker_posts_columns', 'cth_gather_plugins_speakers_columns_head');
add_action('manage_cth_speaker_posts_custom_column', 'cth_gather_plugins_speakers_columns_content', 10, 2);

function cth_gather_plugins_speakers_register_vc_elements(){
    if(function_exists('vc_map')){

        vc_map( array(
            "name"      => __("Speaker Slider", 'cth-gather-plugins'),
            "base"      => "cth_speakers_cpt",
            "class"     => "",
            "icon" => CTH_EVENTRES_DIR_URL . "assets/cththemes-logo.png",
            "category"=>'Gather Add-ons',
            "html_template" => CTH_EVENTRES_DIR.'vc_templates/cth_speakers_cpt.php',
            "params"    => array(
                array(
                    "type" => "textfield", 
                    "heading" => __("Count", 'cth-gather-plugins'), 
                    "param_name" => "count", 
                    "description" => __("Number of speakers to get from.", 'cth-gather-plugins'),
                    "value" => "9"
                ),
                array(
                    "type" => "dropdown", 
                    "class" => "", 
                    "heading" => __('Order Speakers by', 'cth-gather-plugins'), 
                    "param_name" => "order_by", 
                    "value" => array(
                        __('Date', 'cth-gather-plugins') => 'date', 
                        __('ID', 'cth-gather-plugins') => 'ID', 
                        __('Author', 'cth-gather-plugins') => 'author', 
                        __('Title', 'cth-gather-plugins') => 'title', 
                        __('Modified', 'cth-gather-plugins') => 'modified',
                    ), 
                    "description" => __("Order Speakers by", 'cth-gather-plugins'), 
                    "std" => 'date',
                ), 
                array(
                    "type" => "dropdown", 
                    "class" => "", 
                    "heading" => __('Order Speakers', 'cth-gather-plugins'), 
                    "param_name" => "order", 
                    "value" => array(
                        
                        __('Descending', 'cth-gather-plugins') => 'DESC', 
                        __('Ascending', 'cth-gather-plugins') => 'ASC',
                        
                    ), 
                    "description" => __("Order Speakers", 'cth-gather-plugins'),
                    "std" => 'DESC',
                ), 
                array(
                    "type" => "textfield", 
                    "heading" => __("Or Enter Speakers IDs", 'cth-gather-plugins'), 
                    "param_name" => "ids", 
                    "description" => __("Enter speaker ids to show, separated by a comma.", 'cth-gather-plugins')
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Show Popup Detail', 'cth-gather-plugins'),
                    "param_name" => "usepopup",
                    "value" => array(   
                                    __('No', 'cth-gather-plugins') => 'no', 
                                    __('Yes', 'cth-gather-plugins') => 'yes',  
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'no',
                ), 
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Link to single speaker page', 'cth-gather-plugins'),
                    "param_name" => "singlespeaker",
                    "value" => array(   
                                    __('Yes', 'cth-gather-plugins') => 'yes', 
                                    __('No', 'cth-gather-plugins') => 'no', 
                                     
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'yes',
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Show Excerpt', 'cth-gather-plugins'),
                    "param_name" => "showexcerpt",
                    "value" => array(   
                                    __('No', 'cth-gather-plugins') => 'no', 
                                    __('Yes', 'cth-gather-plugins') => 'yes',  
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'no',
                ),
                array(
                    "type"      => "textfield",
                    "class"     => "",
                    //"holder"=>'div',
                    "heading"   => __("Slides to show", 'cth-gather-plugins'),
                    "param_name"=> "slidestoshow",
                    "value"     => "6",

                    "description" => __("Number of slides which will display in viewport.", 'cth-gather-plugins')
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Show Navigation', 'cth-gather-plugins'),
                    "param_name" => "arrows",
                    "value" => array(   
                                    __('Yes', 'cth-gather-plugins') => 'true',  
                                    __('No', 'cth-gather-plugins') => 'false', 
                                    
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'true',
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Show Pagination', 'cth-gather-plugins'),
                    "param_name" => "dots",
                    "value" => array(   
                                    __('No', 'cth-gather-plugins') => 'false', 
                                    __('Yes', 'cth-gather-plugins') => 'true',  
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'false',
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Use Center Mode', 'cth-gather-plugins'),
                    "param_name" => "centermode",
                    "value" => array(   
                                    __('No', 'cth-gather-plugins') => 'false', 
                                    __('Yes', 'cth-gather-plugins') => 'true',  
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'false',
                ),
                array(
                    "type" => "dropdown",
                    //"class"=>"",
                    "heading" => __('Auto Play', 'cth-gather-plugins'),
                    "param_name" => "autoplay",
                    "value" => array(   
                                    __('No', 'cth-gather-plugins') => 'false', 
                                    __('Yes', 'cth-gather-plugins') => 'true',  
                                                                                                                   
                                ),
                    //"description" => __("Set this to No to hide filter buttons bar.", 'cth-gather-plugins'), 
                    'std'=>'false',
                ),
                array(
                    "type"      => "textfield",
                    "class"     => "",
                    //"holder"=>'div',
                    "heading"   => __("Responsive Setting", 'cth-gather-plugins'),
                    "param_name"=> "responsive",
                    "value"     => "1200:5|992:3|520:1",

                    "description" => __("Separated by a '|'. Format: viewport width and number of slides to show separated by a ':'. Example: 1200:5|992:3|520:1", 'cth-gather-plugins')
                ),
                array(
                    "type" => "textfield",
                    "heading" => __("Extra class name", 'cth-gather-plugins'),
                    "param_name" => "el_class",
                    "value"=>'',
                    "description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "wpb")
                ),

            )));


        if ( class_exists( 'WPBakeryShortCode' ) ) {
            class WPBakeryShortCode_Cth_Speakers_Cpt extends WPBakeryShortCode {}
        }

    }
}
add_action('init','cth_gather_plugins_speakers_register_vc_elements' );
function get_cth_speaker_post_type_template($single_template) {
     global $post;

     if ($post->post_type == 'cth_speaker') {
          $single_template = dirname( __FILE__ ) . '/cth_speaker-template.php';
     }
     return $single_template;
}
add_filter( 'single_template', 'get_cth_speaker_post_type_template' );
function cth_gather_plugins_register_sidebars(){
    register_sidebar(
        array(
            'name' => __('Speaker Sidebar Widget', 'cth-gather-plugins'), 
            'id' => 'speaker_sidebar_widget', 
            'description' => __('Sidebar widget on single speaker page', 'cth-gather-plugins'), 
            'before_widget' => '<div id="%1$s" class="widget %2$s">', 
            'after_widget' => '</div>', 
            'before_title' => '<h3 class="widget-title">', 
            'after_title' => '</h3>',
        )
    );
}

add_action('widgets_init', 'cth_gather_plugins_register_sidebars');
