<?php
if ( ! defined('ABSPATH') ) {
    die('Please do not load this file directly!');
}

add_action( 'wp_ajax_nopriv_gather_event_email_registration', 'cththemes_gather_event_email_registration_callback' );
add_action( 'wp_ajax_gather_event_email_registration', 'cththemes_gather_event_email_registration_callback' );
function cththemes_gather_event_email_registration_callback() {
    global $wpdb;

    $register_new_user = false;

    
    
    //$error = '';
    $json = array();
    $json['success'] = 0;
    //$success = '';
    $nonce = $_POST['gather_event_email_registration_nonce'];
    
    if ( ! wp_verify_nonce( $nonce, 'gather_event_email_registration_action' ) )
        die ( '<p class="error">Security checked!, Cheatn huh?</p>' );

    // Post datas
    $res_post_datas = array();

    $res_post_datas['first_name'] = trim($_POST['first_name']);
    $res_post_datas['last_name'] = trim($_POST['last_name']);
    $res_post_datas['email'] = trim($_POST['email']);

    
    $eventres_is_free_email         = get_option('eventres_is_free_email','no' );

    if($eventres_is_free_email == 'yes'){
        $res_post_datas['price'] = '0';
        $res_post_datas['quantity'] = '1';
        $res_post_datas['gateway'] = 'Free Email Registration';
        $res_post_datas['pass'] = 'Email Free';
    }else{
        // for option prices
        $paypal_options = array();
        $paypal_options['on0'] = trim($_POST['on0']);
        $paypal_options['os0'] = trim($_POST['os0']);
        $prices_option = get_option('eventres_item_prices');
        
        if(!empty($prices_option)){
            $op_in = 0;
            foreach ($prices_option as $pr_arr) {
                $paypal_options['option_select'.$op_in] = trim($pr_arr['name']);
                $paypal_options['option_amount'.$op_in] = trim($pr_arr['value']);
                if($paypal_options['os0'] == trim($pr_arr['name'])){
                    //for reservation meta data store
                    $res_post_datas['price'] = trim($pr_arr['value']);
                }

                $op_in++;
            }
        }else{
            $res_post_datas['price'] = '99';
            $paypal_options['option_select0'] = 'Default Pass';
            $paypal_options['option_amount0'] = '99';
        }
        if(!isset($res_post_datas['price'])){
            $res_post_datas['price'] = '99';
        }
        $res_post_datas['quantity'] = trim($_POST['item_quantity']); 
        $res_post_datas['gateway'] = 'Email Registration';
        $res_post_datas['pass'] = trim($_POST['os0']);
    }
        
    if( empty($res_post_datas['first_name'] ) ) {
        $json['message'] = __('First name is required.','cth-gather-plugins');
    }else if( empty( $res_post_datas['last_name'] ) ) {
        $json['message'] = __('Last name is required.','cth-gather-plugins');
    }else if( empty( $res_post_datas['email'] ) ) {
        $json['message'] = __('Email is required.','cth-gather-plugins');
    }else {

        // new in version 2.6
        $reg_limit = get_option('eventres_email_limit','');
        if( $reg_limit !== '' && is_numeric( $reg_limit) && $reg_limit >= 0 ) {
            if($res_post_datas['quantity'] && $res_post_datas['quantity'] > $reg_limit) {
                $json['message'] = __('Invalid quantity value','cth-gather-plugins');

                wp_send_json($json );
            }

            if($reg_limit > 0) {
                $reg_limit = (int) $reg_limit - 1;

                if(!update_option('eventres_email_limit', $reg_limit )){
                    $json['message'] = __('Can not update eventres_email_limit option','cth-gather-plugins');
                    wp_send_json($json );
                }
            }else{
                $json['message'] = __('Sold out!','cth-gather-plugins');
                wp_send_json($json );
            }
        }

        // new in version 2.6 - update reg limit value - eventres_reg_paypal_limit
        // $eventres_email_limit = get_option('eventres_email_limit','' );
        // if( $eventres_email_limit !== '' && is_numeric( $eventres_email_limit) ) {
        //     if($eventres_email_limit > 0) {
        //         $eventres_email_limit = (int) $eventres_email_limit - 1;

        //         if(!update_option('eventres_email_limit', $eventres_email_limit )){
        //             $json['message'] = __('Can not update eventres_email_limit option','cth-gather-plugins');
        //             wp_send_json($json );
        //         }
        //     }else{
        //         $json['message'] = __('Sold out!','cth-gather-plugins');
        //         wp_send_json($json );
        //     }
            
            
        // } 

        /* event reservation datas */
        $auth_key = defined( 'AUTH_KEY' ) ? AUTH_KEY : '';
        $pur_key = strtolower( md5( $res_post_datas['email'] . date( 'Y-m-d H:i:s' ) . $auth_key . uniqid( 'gatherevent', true ) ) );  // Unique key

        $res_datas = array();
        if(isset($res_post_datas['first_name'])|| isset($res_post_datas['last_name'])){
            $res_datas['post_title'] = $res_post_datas['first_name'] .' '.$res_post_datas['last_name'];
        }else{
            $res_datas['post_title'] = $res_post_datas['email'];
        }
        
        //$res_datas['post_name'] = '';
        $res_datas['post_content'] = '';
        //$res_datas['post_author'] = '0';// default 0 for no author assigned
        $res_datas['post_status'] = 'publish';
        $res_datas['post_type'] = 'cth_eventres';

        $res_meta_datas                     = array();
        $res_meta_datas['pur_pass']         = $res_post_datas['pass'];//trim($_POST['os0']);
        $res_meta_datas['pur_price']        = $res_post_datas['price'];
        $res_meta_datas['pur_quantity']     = $res_post_datas['quantity'];
        $res_meta_datas['pur_date']         = date( 'Y-m-d H:i:s', current_time( 'timestamp' ) );
        $res_meta_datas['pur_currency']     = get_option('eventres_currency' );

        $res_meta_datas['pur_key']          = $pur_key;
        $res_meta_datas['pur_custom']       = uniqid();
        $res_meta_datas['pur_gateway']      = $res_post_datas['gateway'];//'Email Registration';
        $res_meta_datas['pur_status']       = 'Pending';

        
        $res_meta_datas['pur_fname']        = $res_post_datas['first_name'];
        $res_meta_datas['pur_lname']        = $res_post_datas['last_name'];
        $res_meta_datas['pur_email']        = $res_post_datas['email'];

        $res_id = wp_insert_post($res_datas ,true );
                    

        if (is_wp_error($res_id)) {
            $json['message'] = $res_id->get_error_message();
        }else{

            
            
            /* email template variable */
            $first_name             = $res_post_datas['first_name'];
            $last_name              = $res_post_datas['last_name'];
            $payer_email            = $res_post_datas['email'];
            $receiver_email         = get_option('eventres_paypal_email');
            $item_name              = get_option('eventres_item_name' );
            $item_number            = $res_meta_datas['pur_custom'];
            $quantity               = $res_post_datas['quantity'];
            $payment_currency       = get_option('eventres_currency');
            $payment_amount         = (float)$res_post_datas['price'] * (int)$quantity;
            $event_pass             = $res_meta_datas['pur_pass'];
            $date                   = $res_meta_datas['pur_date'];
            $sitename               = get_option( 'blogname' );

            $allow_field_names = array('first_name','last_name','payer_email','receiver_email','item_name','item_number','quantity','payment_currency','payment_amount','event_pass','date','sitename','paypal_link','payment_id');

            $eventres_add_fields            = get_option('eventres_add_fields','' );
            if(!empty($eventres_add_fields)){
                foreach ($eventres_add_fields as $key => $field) {
                    $field_name = str_replace(array(" ","-"), "_", $field['name']);
                    if(!isset($res_meta_datas[$field_name])){
                        $res_meta_datas[$field_name] = trim($_POST[$field_name]); 
                    }
                    $allow_field_names[] = $field_name;
                    if(!isset($$field_name)){
                        $$field_name = trim($_POST[$field_name]); 
                    }
                }
            }

            $allow_field_names = array_unique($allow_field_names);

            foreach ($res_meta_datas as $key => $value) {
                if ( !add_post_meta( $res_id, $key, $value , true ) ) {
                    $json['message'] = sprintf(__('Insert reservation %s data failure','cth-gather-plugins'),$key);
                    wp_send_json($json );
                }
            }


            

            $sender_option = get_option('eventres_email_sender','Gather Event' );
            $sender_email_option = get_option('eventres_email_sender_email','contact.cththemes@gmail.com' );

            // to buyer
            if(get_option('eventres_email_res_to_buyer_email','yes' ) === 'yes') : 
                $eventres_email_res_to_buyer_email_subject = get_option('eventres_email_res_to_buyer_email_subject','Your Seat is reserved for the event'); 
                $eventres_email_res_to_buyer_email_template = get_option('eventres_email_res_to_buyer_email_template'); 

                if(preg_match_all("/{([\w_]+)[^\w_]*}/", $eventres_email_res_to_buyer_email_template, $matches)!= FALSE){
                    $fieldsPattern = array();//$matches[0];
                    $fieldsReplace = array();
                    foreach ($matches[1] as $key => $fn) {
                        $fieldsPattern[] = "/{(".$fn.")[^\w_]*}/";

                        if( isset( $$fn )&&in_array( $fn, $allow_field_names ) ){
                            $fieldsReplace[] = $$fn;  //'['.$fn.']';
                        }else{
                            $fieldsReplace[] = '{'.$fn.'}';
                        }
                        
                    }


                    $eventres_email_res_to_buyer_email_template = preg_replace($fieldsPattern, $fieldsReplace, $eventres_email_res_to_buyer_email_template);
                }


                $headers = array();
                if(get_option('eventres_email_content_type','yes' ) == 'yes'){
                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
                }
                
                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_custom_wp_mail_from_name' );
                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

                if (!wp_mail( $payer_email, $eventres_email_res_to_buyer_email_subject , $eventres_email_res_to_buyer_email_template, $headers)) {
                    $json['success']  = 0;  
                    $json['message']  = __('Email send failed','cth-gather-plugins');
                }else{
                    $json['success']  = 1;  
                    $json['message']  = __('Email sent','cth-gather-plugins');
                }
                
                remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_custom_wp_mail_from_name' );

            endif;

            //to admin
            if(get_option('eventres_email_res_to_admin_email','yes' )=== 'yes') :
                $eventres_email_res_to_admin_email_subject = get_option('eventres_email_res_to_admin_email_subject','New Event Registration: $first_name $last_name'); 
                $eventres_email_res_to_admin_email_template = get_option('eventres_email_res_to_admin_email_template'); 
                $email_res_to_admin_email_addresses = get_option('eventres_email_res_to_admin_email_addresses'); 
                if(preg_match_all("/{([\w_]+)[^\w_]*}/", $eventres_email_res_to_admin_email_template, $matches)!= FALSE){
                    $fieldsPattern = array();//$matches[0];
                    $fieldsReplace = array();
                    foreach ($matches[1] as $key => $fn) {
                        $fieldsPattern[] = "/{(".$fn.")[^\w_]*}/";

                        if( isset( $$fn )&&in_array( $fn, $allow_field_names ) ){
                            $fieldsReplace[] = $$fn;  //'['.$fn.']';
                        }else{
                            $fieldsReplace[] = '{'.$fn.'}';
                        }
                        
                    }


                    $eventres_email_res_to_admin_email_template = preg_replace($fieldsPattern, $fieldsReplace, $eventres_email_res_to_admin_email_template);
                }


                $headers = array();
                if(get_option('eventres_email_content_type','yes' ) == 'yes'){
                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
                }
                
                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_custom_wp_mail_from_name' );
                $headers[] = 'Reply-To: '. $first_name.' ' .$last_name .' ' . '<'.$payer_email.'>';
                
                $email_res_to_admin_email_addresses = preg_split( '/\r\n|\r|\n/', trim($email_res_to_admin_email_addresses) );

                if (!wp_mail( array_filter($email_res_to_admin_email_addresses ,'trim'), $eventres_email_res_to_admin_email_subject , $eventres_email_res_to_admin_email_template, $headers) ) {
                    $json['success']  = 0;  
                    $json['message']  = __('Email send failed','cth-gather-plugins');
                }else{
                    $json['success']  = 1;  
                    $json['message']  = __('Email sent','cth-gather-plugins');
                }
                
                remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_custom_wp_mail_from_name' );

            endif;

        }   
    }
    wp_send_json($json );
}

