<?php
if ( ! defined('ABSPATH') ) {
    die('Please do not load this file directly!');
}

if(!function_exists('cth_create_opening_tag_new')){
	function cth_create_opening_tag_new($value) { 

	    echo "<tr valign=\"top\">\n";
	    echo '<th scope="row">';
	    if (isset($value['name'])) {
	        echo esc_attr($value['name'] ) . "\n";
	    }
	    if (isset($value['desc']) && !(isset($value['type']) && $value['type'] == 'checkbox')) {
	        echo "<br /><span class=\"desc\" style=\"font-size:90%;font-weight:400;\">".$value['desc']."</span>";
	    }
	    if (isset($value['note'])) {
	        echo "<br /><span class=\"note\" style=\"font-size:90%;font-weight:400;font-style:italic;\">".$value['note']."</span>";
	    }
	    echo '</th>';
	    echo '<td>';
	 }
}



if(!function_exists('cth_create_closing_tag_new')){
	/**
	 * Creates the closing markup for each option.
	 *
	 * @param $value
	 * @return void
	 */
	function cth_create_closing_tag_new($value) { 
		if (isset($value['add_desc'])) {
	        echo "<br /><span class=\"add_desc\">".$value['add_desc']."</span>";
	    }
	    echo "</td>\n";
	    echo "</tr>\n";
	}
}



if(!function_exists('cth_create_suf_header_3_new')){
	function cth_create_suf_header_3_new($value) { 
	    echo "<tr valign=\"top header_3\">\n";
	    echo '<th scope="row" colspan="2">';
	    if (isset($value['name'])) {
	        echo '<h4 class="section_header">'.esc_attr($value['name'] ) . "</h4>\n";
	    }
	    if (isset($value['desc']) && !(isset($value['type']) && $value['type'] == 'checkbox')) {
	        echo "<br /><span class=\"desc\" style=\"font-size:90%;font-weight:400;\">".$value['desc']."</span>";
	    }
	    if (isset($value['note'])) {
	        echo "<br /><span class=\"note\" style=\"font-size:90%;font-weight:400;font-style:italic;\">".$value['note']."</span>";
	    }
	    echo '</th>';
	    echo '</tr>';

	    //echo '<h3 class="suf-header-3">'.$value['name']."</h3>\n"; 
	}
}


if(!function_exists('cth_create_section_for_text_new')){
	function cth_create_section_for_text_new($value) { 
	    cth_create_opening_tag_new($value);
	    $text = "";
	    global $gather_stripe_options, $global_opt_name ;
	    if(!isset($gather_stripe_options[$value['id']] )){
	    	$text = $value['std'];
	    }else{
	    	$text = $gather_stripe_options[$value['id']] ;
	    }
	    echo '<input type="text" ';//id="'.$global_opt_name.'['.$value['id'].']'.'"';
	    if(isset($value['style'])&& !empty($value['style'])){
	        echo ' style="'.$value['style'].'"';
	    }
	    if(isset($value['required'])&& $value['required']){
	        echo ' required ';
	    }
	    echo ' placeholder="'.esc_attr($value['name'] ).'" name="'.$global_opt_name.'['.$value['id'].']'.'" value="'.$text.'" />'."\n";
	    cth_create_closing_tag_new($value);
	}
}


if(!function_exists('cth_create_section_for_textarea_new')){
	function cth_create_section_for_textarea_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	    

	    echo '<textarea name="'.$global_opt_name.'['.$value['id'].']'.'" type="textarea" cols="'.esc_attr($value['cols'] ).'" rows="'.esc_attr($value['rows'] ).'"';
	    if(isset($value['style'])&& !empty($value['style'])){
	        echo ' style="'.$value['style'].'" ';
	    }
	    echo '>'."\n";
	    if(!isset($gather_stripe_options[$value['id']] )){
	    	echo $value['std'];
	    }else{
	    	echo $gather_stripe_options[$value['id']] ;
	    }
	    echo '</textarea>';
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_editor_new')){
	function cth_create_section_for_editor_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	    if(!isset($gather_stripe_options[$value['id']] )){
	    	$e_content = $value['std'];
	    }else{
	    	$e_content = $gather_stripe_options[$value['id']] ;
	    }
	    /**
	     * 2.
	     * This code renders an editor box and a submit button.
	     * The box will have 15 rows, the quicktags won't load
	     * and the PressThis configuration is used.
	     */
	    $args = array(
	        'textarea_rows' => esc_attr($value['rows'] ),
	        'textarea_name'=> $global_opt_name.'['.$value['id'].']',
	        'teeny' => true,
	        'quicktags' => true
	    );
	    wp_editor( $e_content, $global_opt_name.'_'.$value['id'].'_', $args );
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_ace_editor_new')){
	function cth_create_section_for_ace_editor_new($value) {
	    cth_create_opening_tag_new($value);
	    if (!isset($value['ace_mode'])) {
	        $value['ace_mode'] = 'html';
	    }
	    if (isset($value['ace_style'])) {
	        $ace_style = 'style="' . $value['ace_style'] . '"';
	    } 
	    else {
	        $ace_style = 'style="min-height:300px;border:1px solid #bbb;"';
	    }
	    global $gather_stripe_options, $global_opt_name ;
	    if(!isset($gather_stripe_options[$value['id']] )){
	    	$e_content = $value['std'];
	    }else{
	    	$e_content = $gather_stripe_options[$value['id']] ;
	    }

	    echo '<div id="'.$global_opt_name.'['.$value['id'].']'.'" ' . $ace_style . '></div>';

	    echo '<input name="' . esc_attr($value['id']) . '" class="cth_ace_field" type="hidden" value="' . esc_attr($e_content) . '" />';
	    echo '<script src="' . CTH_EVENTRES_DIR_URL . 'assets/js/ace/src-min-noconflict/ace.js" type="text/javascript" charset="utf-8"></script>';
	    echo '<script src="' . CTH_EVENTRES_DIR_URL . 'assets/js/ace/src-min-noconflict/mode-' . esc_attr($value['ace_mode']) . '.js" type="text/javascript" charset="utf-8"></script>';
	    echo '<script>';
	        echo 'var '.$global_opt_name.'_'.$value['id'].'_'.' = ace.edit("'.$global_opt_name.'['.$value['id'].']'.'");';
	        echo $global_opt_name.'_'.$value['id'].'_'.'.getSession().setMode("ace/mode/' . esc_attr($value['ace_mode']) . '");';
	        echo $global_opt_name.'_'.$value['id'].'_'.'.setValue( jQuery("#'.$global_opt_name.'['.$value['id'].']'.'").next(".cth_ace_field").val() );';
	        echo $global_opt_name.'_'.$value['id'].'_'.'.getSession().on("change", function(e) {';
	                echo 'jQuery("#'.$global_opt_name.'['.$value['id'].']'.'").next(".cth_ace_field").val( '.$global_opt_name.'_'.$value['id'].'_'.'.getValue() );';
	        echo '});';
	    echo '</script>';
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_color_picker_new')){
	function cth_create_section_for_color_picker_new($value) { 
	    cth_create_opening_tag_new($value);
	    $color_value = "";
	    global $gather_stripe_options, $global_opt_name ;
	    if(!isset($gather_stripe_options[$value['id']] )){
	    	$color_value = $value['std'];
	    }else{
	    	$color_value = $gather_stripe_options[$value['id']] ;
	    }
	 
	    echo '<div class="color-picker">'."\n";
	    echo '<input type="text" id="'.$global_opt_name.'['.$value['id'].']'.'" name="'.$global_opt_name.'['.$value['id'].']'.'" value="'.$color_value.'" class="color" />';
	    echo ' « Click to select color<br/>'."\n";
	    echo "<strong>Default: <font color='".$value['std']."'> ".$value['std']."</font></strong>";
	    echo " (You can copy and paste this into the box above)\n";
	    echo "</div>\n";
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_radio_new')){
	function cth_create_section_for_radio_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	    foreach ($value['options'] as $option_value => $option_text) {
	        $checked = ' ';
	        if(isset($gather_stripe_options[$value['id']] ) && $gather_stripe_options[$value['id']] == $option_value ){
		    	$checked = ' checked="checked" ';
		    }elseif( !isset($gather_stripe_options[$value['id']] ) && $value['std'] == $option_value ){
		    	$checked = ' checked="checked" ';
		    }
	        echo '<div class="mnt-radio" style="display:inline-block;padding:0 10px 0 0;"><input type="radio" name="'.$global_opt_name.'['.$value['id'].']'.'" value="'.
	            $option_value.'" '.$checked."/>".$option_text."</div>\n";
	    }
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_checkbox_new')){
	function cth_create_section_for_checkbox_new($value) { 
	    cth_create_opening_tag_new($value);
	    $checked = '';
	    global $gather_stripe_options, $global_opt_name ;
	    // if( isset( $value['std']) && $value['std'] == $value['value'] ){
	    // 	$checked = ' checked="checked" ';
	    // }
	    if(isset($gather_stripe_options[$value['id']] ) && $gather_stripe_options[$value['id']] == $value['value'] ){
	    	$checked = ' checked="checked" ';
	    }

	    echo '<div><input type="checkbox" name="'.$global_opt_name.'['.$value['id'].']'.'" value="'.$value['value'].'" '.$checked."/> ".$value['desc'].'</div>';
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_multi_select_new')){
	function cth_create_section_for_multi_select_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	    echo '<ul class="mnt-checklist" id="'.$value['id'].'" >'."\n";
	    foreach ($value['options'] as $option_value => $option_list) {
	        $checked = " ";
	        // if (get_option($value['id']."_".$option_value)) {
	        //     $checked = " checked='checked' ";
	        // }
	        if(isset($gather_stripe_options[$value['id']][$option_value] ) ){
		    	$checked = ' checked="checked" ';
		    }
	        echo "<li>\n";
	        //echo '<input type="checkbox" name="'.$value['id']."_".$option_value.'" value="true" '.$checked.' class="depth-'.($option_list['depth']+1).'" />'.$option_list['title']."\n";
	        echo '<input type="checkbox" name="'.$global_opt_name.'['.$value['id'].']'."[".$option_value.']'.'" value="true" '.$checked.' class="depth-'.($option_list['depth']+1).'" />'.$option_list['title']."\n";
	        echo "</li>\n";
	    }
	    echo "</ul>\n";
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_select_new')){
	function cth_create_section_for_select_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	        echo "<select id='".$global_opt_name.'['.$value['id'].']'."' class='post_form' name='".$global_opt_name.'['.$value['id'].']'."'>\n";
	            
	            foreach ($value['options'] as $option_value => $option_list) {
	                $selected = ' ';
	                
		            if(isset($gather_stripe_options[$value['id']] ) && $gather_stripe_options[$value['id']] == $option_value ){
		                $selected = ' selected="selected" ';
		            }
		            elseif ( !isset($gather_stripe_options[$value['id']] ) && $value['std'] == $option_value ){
		                $selected = ' selected="selected" ';
		            }
		    
	                echo '<option value="'.$option_value.'" '.$selected.'/>'.$option_list."</option>\n";
	            }   
	        echo "</select>\n </div>";
	    cth_create_closing_tag_new($value);
	}
}

if(!function_exists('cth_create_section_for_repeatable_new')){
	function cth_create_section_for_repeatable_new($value) { 
	    cth_create_opening_tag_new($value);
	    //$repeat_vs = get_option($value['id']);
	    global $gather_stripe_options, $global_opt_name ;
	    if(isset($gather_stripe_options[$value['id']] )){
	    	$opt_vals = $gather_stripe_options[$value['id']] ;
	    }elseif(isset($value['std']) && is_array($value['std']) && isset($value['can_empty']) && !$value['can_empty'] ){
	    	$opt_vals = $value['std'];
	    }
	    	echo '
	    	<table class="repeatable_table">
	    		<tr>
	    			<th>Option Name</th>
	    			<th>Option Value</th>
	    			<th></th>

	    		</tr>';
	    		echo 	'<tr data-key="0" class="hide"></tr>';
	    	if( !empty( $opt_vals ) ) {
	    		foreach ( $opt_vals as $key => $val) {
	    			echo '<tr data-key="'.$key.'">';
	    			if(isset($val['name'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][name]" value="'.$val['name'].'" placeholder="Option Name"></td>';
	    			}
	    			if(isset($val['value'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]" value="'.$val['value'].'" placeholder="Option Value"></td>';
	    			}
	    			echo '<td><a href="#" class="repeatable_remove_option">Remove Option</a></td></tr>';
	    		}
	    	}

	    	echo '<tr><td><a href="#" class="repeatable_add_option" data-name="'.$global_opt_name.'['.$value['id'].']'.'" data-fields="'/*.rawurlencode(json_encode($value['fields']))*/.'">Add Option</a><td><td></td></tr>';
	    		
	    	echo '</table>';
	    cth_create_closing_tag_new($value);
	}
}
if(!function_exists('cth_create_section_for_repeatable_two_new')){
	function cth_create_section_for_repeatable_two_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;
	    if(isset($gather_stripe_options[$value['id']] )){
	    	$opt_vals = $gather_stripe_options[$value['id']] ;
	    }elseif(isset($value['std']) && is_array($value['std']) && isset($value['can_empty']) && !$value['can_empty'] ){
	    	$opt_vals = $value['std'];
	    }
	    echo '
	    	<table class="repeatable_table">
	    		<tr>
	    			<th>'.$value['field_texts']['name'].'</th>
	    			<th>'.$value['field_texts']['value'].'</th>
	    			<th></th>

	    		</tr>';
	    		echo 	'<tr data-key="0" class="hide"></tr>';
	    	if( !empty( $opt_vals ) ){
	    		foreach ( $opt_vals as $key => $val) {
	    			echo '<tr data-key="'.$key.'">';
	    			if(isset($val['name'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][name]" value="'.$val['name'].'" placeholder="'.$value['field_texts']['name'].'"></td>';
	    			}
	    			if(isset($val['value'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]" value="'.$val['value'].'" placeholder="'.$value['field_texts']['value'].'"></td>';
	    			}
	    			echo '<td><a href="#" class="repeatable_remove_option">'.$value['field_texts']['remove'].'</a></td></tr>';
	    		}
	    	}
	    	// else{
	    	// 	echo 	'<tr data-key="0">
			   //  			<td><input type="text" name="'.$value['id'].'[0][name]"></td>
			   //  			<td><input type="text" name="'.$value['id'].'[0][value]"></td>
		    // 			</tr>';
	    	// }
	    	//echo'<pre>';var_dump($value['fields']);die;

	    	echo '<tr><td><a href="#" class="repeatable_add_option" data-name="'.$global_opt_name.'['.$value['id'].']'.'" data-fields="'/*.rawurlencode(json_encode($value['fields']))*/.'">'.$value['field_texts']['add'].'</a><td><td></td></tr>';
	    		
	    	echo '</table>';
	    cth_create_closing_tag_new($value);
	}
}
if(!function_exists('cth_create_section_for_list_pages_select_new')){
	function cth_create_section_for_list_pages_select_new($value) { 
		$all_page_ids = get_all_page_ids();
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name;
	    if(!empty($all_page_ids)){
	    echo "<select id='".$global_opt_name.'['.$value['id'].']'."' class='post_form' name='".$global_opt_name.'['.$value['id'].']'."'>\n";
	    	foreach ($all_page_ids as $key => $p_id) {
	    		$p_p = get_post($p_id);
	    		if($p_p->post_status == 'publish'){
	    			$selected = ' ';
	                if(isset($gather_stripe_options[$value['id']] ) && $gather_stripe_options[$value['id']] == $p_id ){
		            //if (get_option($value['id']) == $p_id) {
		            	//var_dump( $gather_stripe_options[$value['id']] );
		                $selected = ' selected="selected" ';
		            }
		            elseif( !isset($gather_stripe_options[$value['id']] ) && $value['default_title'] == $p_p->post_title){
		                $selected = ' selected="selected" ';
		            }
		    
	                echo '<option value="'.$p_id.'" '.$selected.'/>'.$p_p->post_title."</option>\n";
	    		}
	    		
	    	}
	    echo "</select>\n </div>";
	    } 
	        
	    cth_create_closing_tag_new($value);
	}
}
if(!function_exists('cth_create_section_for_repeatable_fields_new')){
	function cth_create_section_for_repeatable_fields_new($value) { 
	    cth_create_opening_tag_new($value);
	    global $gather_stripe_options, $global_opt_name ;

	    //$repeat_vs = get_option($value['id']);
	    
	    	echo '
	    	<table class="repeatable_table">
	    		<tr>
	    			<th>Field Type</th>
	    			<th>Field Name</th>
	    			<th>Field Label</th>
	    			<th class="field_values_col">Field Values</th>

	    		</tr>';
	    		echo 	'<tr data-key="0" class="hide"></tr>';
	    	if( isset($gather_stripe_options[$value['id']] ) && !empty( $gather_stripe_options[$value['id']] ) ){
	    		foreach ( $gather_stripe_options[$value['id']] as $key => $val) {
	    	// if($repeat_vs && !empty($repeat_vs)){
	    	// 	foreach ($repeat_vs as $key => $val) {
	    			echo '<tr data-key="'.$key.'">';
	    			if(isset($val['type'])){
	    				echo '<td><select name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][type]" class="select_field_type" data-name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.']" data-type="'.$val['type'].'"';
	    					// if($val['type'] == 'select'){
	    					// 	if(isset($val['value'])){
	    					// 		echo ' data-select-value=\''.json_encode($val['value']).'\'';
	    					// 	}else{
	    					// 		echo ' data-select-value=""';
	    					// 	}
	    						
	    					// 	echo ' data-text-value="" data-textarea-value=""';
	    					// }elseif($val['type'] == 'text'){
	    					// 	echo ' data-text-value="'.$val['value'].'" data-textarea-value="" data-select-value=""';
	    					// }elseif($val['type'] == 'textarea'){
	    					// 	echo ' data-textarea-value="'.$val['value'].'" data-text-value="" data-select-value=""';
	    					// }
	    				echo '>';

									echo '<option value="text"'.(($val['type'] == 'text')? ' selected="selected"' : '').'>Text Field</option>
									<option value="select"'.(($val['type'] == 'select')? ' selected="selected"' : '').'>Select Field</option>
									<option value="textarea"'.(($val['type'] == 'textarea')? ' selected="selected"' : '').'>Textarea Field</option>';
						echo '</select></td>';
	    			}
	    			if(isset($val['name'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][name]" value="'.$val['name'].'" placeholder="Field Name"></td>';
	    			}
	    			if(isset($val['label'])){
	    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][label]" value="'.$val['label'].'" placeholder="Field Label"></td>';
	    			}
	    			// if(isset($val['value'])){echo'<pre>val value';var_dump($val['value']);
	    				if(isset($val['type']) && $val['type'] == 'select'){
	    					echo '<td  class="field_values_col field_select_ops">';
	    						echo '<table><tr data-key="0" class="hide"></tr>';

		    					if(!empty($val['value'])){
		    						foreach ((array)$val['value'] as $op_in => $sl_ops) {
		    							echo '<tr data-key="'.$op_in.'">';
						    			if(isset($sl_ops['name'])){
						    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]['.$op_in.'][name]" value="'.$sl_ops['name'].'" placeholder="Option Name"></td>';
						    			}
						    			if(isset($sl_ops['value'])){
						    				echo '<td><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]['.$op_in.'][value]" value="'.$sl_ops['value'].'" placeholder="Option Value"></td>';
						    			}
						    			echo '<td><a href="#" class="repeatable_fields_select_remove_option">Remove Option</a></td></tr>';
		    						}
		    						// echo 	'<tr data-key="0">
								    // 			<td><input type="text" name="'.$value['id'].'['.$key.'][value][0][name]" placeholder="Option Name"></td>
								    // 			<td><input type="text" name="'.$value['id'].'['.$key.'][value][0][value]" placeholder="Option Value"></td>
							    	// 		</tr>';
		    					}
		    					// else{
		    					// 	echo 	'<tr data-key="0">
								   //  			<td><input type="text" name="'.$value['id'].'['.$key.'][value][0][name]" placeholder="Option Name"></td>
								   //  			<td><input type="text" name="'.$value['id'].'['.$key.'][value][0][value]" placeholder="Option Value"></td>
								   //  			<td><a href="#" class="repeatable_fields_select_remove_option">Remove Option</a></td>
							    // 			</tr>';
		    					// }
		    					echo '<tr><td><a href="#" class="repeatable_fields_select_add_option" data-name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]">Add Option</a><td><td></td></tr>';
		    					echo '</table>';

	    					echo '</td>';
	    				}else{
	    					echo '<td  class="field_values_col"><input type="text" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][value]" value="'.$val['value'].'"  placeholder="Field Value"></td>';
	    				}
	    				
	    			// }
	    			//if(isset($val['required'])){
	    				$checked = '';
	    				if(isset($val['required'])&&$val['required'] === 'true'){
					    	$checked = ' checked="checked" ';
					    }
					    // elseif($value['std'] == 'checked'){
					    // 	$checked = ' checked="checked" ';
					    // }

					    // echo '<div><input type="checkbox" name="'.$value['id'].'" value="'.$value['value'].'" '.$checked."/> ".$value['desc'].'</div>';
	    				echo '<td><input type="checkbox" name="'.$global_opt_name.'['.$value['id'].']'.'['.$key.'][required]" value="true" '.$checked.'/>Required Field?</td>';
	    			//}
	    			echo '<td><a href="#" class="repeatable_fields_remove_field">Remove Field</a></td></tr>';
	    		}
	    	}
	    	// else{
	    	// 	echo 	'<tr data-key="0">
			   //  			<td>
			   //  				<select name="'.$value['id'].'[0][type]" class="select_field_type" data-name="'.$value['id'].'[0]">
						// 			<option value="text" selected="selected">Text Field</option>
						// 			<option value="select">Select Field</option>
						// 			<option value="textarea">Textarea Field</option>
						// 		</select>
			   //  			</td>
			   //  			<td><input type="text" name="'.$value['id'].'[0][name]"></td>
			   //  			<td><input type="text" name="'.$value['id'].'[0][label]"></td>
			   //  			<td class="field_values_col"><input type="text" name="'.$value['id'].'[0][value]"></td>
			   //  			<td><a href="#" class="repeatable_fields_remove_field">Remove Field</a></td>
		    // 			</tr>';
	    	// }
	    	//echo'<pre>';var_dump($value['fields']);die;

	    	echo '<tr><td><a href="#" class="repeatable_fields_add_field" data-name="'.$global_opt_name.'['.$value['id'].']'.'">Add field</a><td><td></td></tr>';
	    		
	    	echo '</table>';
	    	
	        // echo "<select id='".$value['id']."' class='post_form' name='".$value['id']."'>\n";
	            
	        //     foreach ($value['options'] as $option_value => $option_list) {
	        //         $selected = ' ';
	                
		       //      if (get_option($value['id']) == $option_value) {
		       //          $selected = ' selected="selected" ';
		       //      }
		       //      else if (get_option($value['id']) === FALSE && $value['std'] == $option_value){
		       //          $selected = ' selected="selected" ';
		       //      }
		    
	        //         echo '<option value="'.$option_value.'" '.$selected.'/>'.$option_list."</option>\n";
	        //     }   
	        // echo "</select>\n </div>";
	    cth_create_closing_tag_new($value);
	}
}