<?php

function cth_eventres_plugin_export_settings_setup() {
	//add_options_page('Stripe Settings', 'Stripe Settings', 'manage_options', 'stripe-settings', 'cth_eventres_plugin_stripe_options');
	add_submenu_page( 
        'edit.php?post_type=cth_striperes',
        'Export Registration Options', // $page_title - (string) (required) The text to be displayed in the title tags of the page when the menu is selected 
        'Export Registrations', //  $menu_title - (string) (required) The text to be used for the menu 
        'manage_options', // $capability - (string) (required) The capability required for this menu to be displayed to the user. 
        'cth_eventres_export', //menu_slug - (string) (required) The slug name to refer to this menu by (should be unique for this menu). 
        'cth_eventres_plugin_export_options' // $function - (callback) (optional) The function to be called to output the content for this page. 
    );
}
add_action('admin_menu', 'cth_eventres_plugin_export_settings_setup');

function cth_eventres_plugin_export_options() {
	//global $cth_eventres_stripe_options_array ;
	?>
	<div class="wrap">
		
		<form method="post" action="options.php">
 			
 			<?php settings_fields('cth_eventres_export_group'); ?>

	        <?php //do_settings_fields('cth_eventres_export','cth_eventres_export-section'); ?>

	        <?php do_settings_sections('cth_eventres_export'); ?>

	        <?php submit_button(); ?>

	        <h3><?php _e('Export Registrations:','cth-gather-plugins');?></h3>

	        <p><?php _e('You have to select which datas you want to export and save the changes first.','cth-gather-plugins');?></p>
	        
	        <a class="eventres_export_button button button-primary" href="edit.php?post_type=cth_striperes&page=cth_eventres_export&eventres_export=yes"><?php _e('Export Registrations','cth-gather-plugins');?></a>
		</form>
	</div>
	<?php
}

function cth_eventres_plugin_export_register_settings() {
	// creates our settings in the options table

	register_setting('cth_eventres_export_group', 'eventres_export_post_type');
	register_setting('cth_eventres_export_group', 'eventres_export_std_fields');
	register_setting('cth_eventres_export_group', 'eventres_export_custom_fields');

	add_settings_section(
        'cth_eventres_export-section', 
        'Custom CSV Export Settings', 
        'cth_eventres_settings_section_export_template', 
        'cth_eventres_export'
    );

    add_settings_field(
        'eventres_export_post_type', 
        'Select Registration Type to Export', 
        'cth_eventres_settings_field_select_post_type_fields', 
        'cth_eventres_export', 
        'cth_eventres_export-section'
    );

    add_settings_field(
        'eventres_export_std_fields', 
        'Standard Fields to Export', 
        'cth_eventres_settings_field_select_std_fields', 
        'cth_eventres_export', 
        'cth_eventres_export-section'
    );

	add_settings_field(
        'eventres_export_custom_fields', 
        'Custom Fields to Export', 
        'cth_eventres_settings_field_select_custom_fields', 
        'cth_eventres_export', 
        'cth_eventres_export-section'
    );

}
add_action('admin_init', 'cth_eventres_plugin_export_register_settings');

function cth_eventres_settings_section_export_template(){
	_e('These are the settings for the Registration CSV Export.','cth-gather-plugins');
}

function cth_eventres_settings_field_select_post_type_fields() {
	$eventres_post_type = get_option('eventres_export_post_type','cth_eventres');

	$defaults = array(
		'cth_eventres' => __('Gather Event Registrations','cth-gather-plugins'),
		'cth_striperes' => __('Stripe Subscriptions','cth-gather-plugins'),
	);

	echo '<select name="eventres_export_post_type">';
    foreach ($defaults as $op => $name ) {

    	 echo '\n\t\<option value="'.$op .'" '.selected( $eventres_post_type, $op, false).'>'.$name.'</option>';
    } // END public function settings_field_input_text($args)

    echo '</select>';

}

function cth_eventres_settings_field_select_std_fields(){
	$eventres_post_type = get_option('eventres_export_post_type','cth_eventres');
    $fields = cth_eventres_export_generate_std_fields($eventres_post_type);
    $eventres_export_std_fields =get_option('eventres_export_std_fields');
    $eventres_std_fields_num = count($fields);
    echo '<select multiple="multiple" size="'.$eventres_std_fields_num.'" name="eventres_export_std_fields[selectinput][]">';
    foreach ($fields as $field) {
    	if (in_array($field, $eventres_export_std_fields['selectinput'])){
    	 echo '\n\t<option selected="selected" value="'. $field . '">'.$field.'</option>'; 
    	} else {
    	 echo '\n\t\<option value="'.$field .'">'.$field.'</option>'; }
    } // END public function settings_field_input_text($args)

    echo '</select>';

}

function cth_eventres_settings_field_select_custom_fields(){
	$eventres_post_type = get_option('eventres_export_post_type','cth_eventres');
	$meta_keys = cth_eventres_export_get_post_meta_keys($eventres_post_type);
    $eventres_export_custom_fields = get_option('eventres_export_custom_fields');
    $eventres_meta_keys_num = count($meta_keys);
    echo '<select multiple="multiple" size="'.$eventres_meta_keys_num.'" name="eventres_export_custom_fields[selectinput][]">';
    foreach ($meta_keys as $meta_key) {
    	if (in_array($meta_key, $eventres_export_custom_fields['selectinput'])){
    	 echo '\n\t<option selected="selected" value="'. $meta_key . '">'.$meta_key.'</option>'; 
    	} else {
    	 echo '\n\t\<option value="'.$meta_key .'">'.$meta_key.'</option>'; }

   	}

   	echo '</select>';


}

function cth_eventres_export_generate_std_fields($post_type){
    $fields = array();
    $q = new WP_Query(array('post_type' => $post_type, 'post_status' => 'publish', 'posts_per_page' => 1));
    $p = $q->posts[0];

    $allow_fields = array('ID','post_author','post_date','post_date_gmt','post_content','post_title','post_status','post_type');
    
    foreach($p as $f => $v) {
    	if(in_array($f, $allow_fields)) $fields[] = $f;
    }
    return $fields;
}


function cth_eventres_export_get_post_meta_keys($post_type){
    $cache = get_transient($post_type.'post_meta_keys');
    $meta_keys = $cache ? $cache : cth_eventres_export_generate_post_meta_keys($post_type);
    return $meta_keys;
}

function cth_eventres_export_generate_post_meta_keys($post_type){
	global $wpdb;
    $query = "
        SELECT DISTINCT($wpdb->postmeta.meta_key) 
        FROM $wpdb->posts 
        LEFT JOIN $wpdb->postmeta 
        ON $wpdb->posts.ID = $wpdb->postmeta.post_id 
        WHERE $wpdb->posts.post_type = '%s' 
        AND $wpdb->postmeta.meta_key != '' 
        AND $wpdb->postmeta.meta_key NOT RegExp '(^[_0-9].+$)' 
        AND $wpdb->postmeta.meta_key NOT RegExp '(^[0-9]+$)'
    ";
    $meta_keys = $wpdb->get_col($wpdb->prepare($query, $post_type));
    set_transient($post_type.'post_meta_keys', $meta_keys, 60*60*24); # 1 Day Expiration
    return $meta_keys;
}


add_action('init','eventres_csv_export' );


if(!function_exists('eventres_csv_export')){
	function eventres_csv_export(){
		$eventres_export_check = isset($_REQUEST['eventres_export']) ? $_REQUEST['eventres_export'] : '';
		if ($eventres_export_check == 'yes') {          
			echo eventres_generate();
			exit;
		}
	}
}

if(!function_exists('eventres_generate')){
	function eventres_generate(){
		// Get the custom post type that is being exported
		$eventres_generate_post_type = get_option('eventres_export_post_type','cth_eventres');
		//$eventres_generate_post_type = 'cth_eventres';// get_option('eventres_post_type');
		// Get the custom fields (for the custom post type) that are being exported
		$eventres_generate_custom_fields = get_option('eventres_export_custom_fields');
	    $eventres_generate_std_fields = get_option('eventres_export_std_fields');
	    //$eventres_generate_tax_terms = get_option('eventres_tax_terms');
		// Query the DB for all instances of the custom post type
		$eventres_generate_query = get_posts(array('post_type' => $eventres_generate_post_type, 'post_status' => 'publish', 'posts_per_page' => -1));
		// Count the number of instances of the custom post type
		$eventres_count_posts = count($eventres_generate_query);	
		
		// Build an array of the custom field values
		$eventres_generate_value_arr = array();
		$i = 0; 
		foreach ($eventres_generate_query as $post): 

			setup_postdata($post);

			// $post->permalink = get_permalink($post->ID);
			// $post->post_thumbnail = wp_get_attachment_url( get_post_thumbnail_id($post->ID) );
	        // get the standard wordpress fields for each instance of the custom post type 
	        foreach($post as $key => $value) {
	            if(in_array($key, $eventres_generate_std_fields['selectinput'])) {
	                $eventres_generate_value_arr[$key][$i] = $post->$key;
	            }
	        }
	        // get the custom field values for each instance of the custom post type 
			$eventres_generate_post_values = get_post_custom($post->ID);		  
			foreach ($eventres_generate_custom_fields['selectinput'] as $key) {
			  	// check if each custom field value matches a custom field that is being exported
				if (array_key_exists($key, $eventres_generate_post_values)) {
				  	// if the the custom fields match, save them to the array of custom field values
					$eventres_generate_value_arr[$key][$i] = $eventres_generate_post_values[$key]['0'];
					 
				} 
			  
			}
			// get custom taxonomy information
	       	// foreach($eventres_generate_tax_terms['selectinput'] as $tax) {
         //        $names = array();
         //        $terms = wp_get_object_terms($post->ID, $tax);
         //        foreach($terms as $t) {
         //            $names[] = $t->name;
         //        }
         //        $eventres_generate_value_arr[$tax][$i] = implode(',', $names);
         //    }
			$i++;
			 
		endforeach;	

		//echo'<pre>';var_dump($eventres_generate_value_arr);
		// create a new array of values that reorganizes them in a new multidimensional array where each sub-array contains all of the values for one custom post instance
		$eventres_generate_value_arr_new = array();
		
		foreach($eventres_generate_value_arr as $value) {
			$i = 0;
			while ($i <= ($eventres_count_posts-1)) {
				$eventres_generate_value_arr_new[$i][] = isset( $value[$i] ) ? $value[$i] : '';

				

				$i++;
			}
		}

		//echo'<pre>';var_dump($eventres_generate_value_arr_new);die;
		// build a filename based on the post type and the data/time
		$eventres_generate_csv_filename = $eventres_generate_post_type.'-'.date('Ymd_His').'-export.csv';
		
		//output the headers for the CSV file
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header('Content-Description: File Transfer');
		header("Content-type: text/csv");
		header("Content-Disposition: attachment; filename={$eventres_generate_csv_filename}");
		header("Expires: 0");
		header("Pragma: public");
	 
		//open the file stream
		$fh = @fopen( 'php://output', 'w' );
		
		$headerDisplayed = false;
	 
		foreach ( $eventres_generate_value_arr_new as $data ) {
	    // Add a header row if it hasn't been added yet -- using custom field keys from first array
	    if ( !$headerDisplayed ) {
	        fputcsv($fh, array_keys($eventres_generate_value_arr));
	        $headerDisplayed = true;
	    }
	 
	    // Put the data from the new multi-dimensional array into the stream
	    fputcsv($fh, $data);
	}
	// Close the file stream
	fclose($fh);
	// Make sure nothing else is sent, our file is done
	exit;



	}
}