<?php

add_action( 'wp_ajax_stripres_get_plan_details', 'stripres_get_plan_details_callback' );

if(!function_exists('stripres_get_plan_details_callback')){
	function stripres_get_plan_details_callback() {
		if(isset($_POST['plan_id']) && $_POST['plan_id'] != '' ){

			require_once CTH_EVENTRES_DIR .'includes/stripe-php/init.php';
			global $gather_stripe_options;
		    if(isset($gather_stripe_options['stripe_test_mode']) && $gather_stripe_options['stripe_test_mode']) {
		        $secret_key = $gather_stripe_options['test_secret_key'];
		    } else {
		        $secret_key = $gather_stripe_options['live_secret_key'];
		    }
		    \Stripe\Stripe::setApiKey( $secret_key );

		    try {
		    	$plan = \Stripe\Plan::retrieve($_POST['plan_id']);
		    	
		    	ob_start();
		    	?>
				<table>
					<tr>
						<th>Name</th>
						<th>ID</th>
						<th>Currency</th>
						<th>Amount</th>
						<th>Interval</th>
						<th>Interval Count</th>
						<th>Trial Days</th>
					</tr>

					<tr>
						<td><?php echo $plan->name;?></td>
						<td><?php echo $plan->id;?></td>
						<td><?php echo $plan->currency;?></td>
						<td><?php echo number_format( $plan->amount / 100 , 2, '.','');?></td>
						<td><?php echo $plan->interval;?></td>
						<td><?php echo $plan->interval_count;?></td>
						<td><?php echo isset($plan->trial_period_days) ? $plan->trial_period_days : 'No';?></td>
					</tr>

					<tr class="summary">
						<td><strong><?php _e('Plan Summary: ','cth-gather-plugins');?></strong></td>
						<td colspan="6"><?php echo sprintf(__('<strong>%s %s</strong> per <strong>%s-%s</strong> with <strong>%s trial days</strong>','cth-gather-plugins'), number_format( $plan->amount / 100 , 2, '.','') , $plan->currency , $plan->interval_count ,  $plan->interval, isset($plan->trial_period_days) ? $plan->trial_period_days : __('0','cth-gather-plugins')  );?></td>
					</tr>





					<!-- <tr>
						<td>Name</td>
						<td><?php echo $plan->name;?></td>
					</tr>
					<tr>
						<td>ID</td>
						<td><?php echo $plan->id;?></td>
					</tr>
					<tr>
						<td>amount</td>
						<td><?php echo $plan->amount;?></td>
					</tr>
					<tr>
						<td>currency</td>
						<td><?php echo $plan->currency;?></td>
					</tr>
					<tr>
						<td>interval</td>
						<td><?php echo $plan->interval;?></td>
					</tr>
					<tr>
						<td>interval_count</td>
						<td><?php echo $plan->interval_count;?></td>
					</tr>
					<tr>
						<td>trial_period_days</td>
						<td><?php echo $plan->trial_period_days;?></td>
					</tr>
					<tr>
						<td>statement_descriptor</td>
						<td><?php echo $plan->statement_descriptor;?></td>
					</tr> -->
					
				</table>
		    	<?php

		    	$output = ob_get_clean();
		    	echo $output;
		    } catch (Exception $e) {
		    	echo $e->getMessage();
		    }

		}else{
			echo 'The plan is invalid.';
		}

		wp_die();
	}
}