<?php
/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $form_title
 * @var $button
 * @var $submit
 * Shortcode class
 * @var $this WPBakeryShortCode_Cth_Paypal_Registration
 */
$el_class = $form_title = $button_text = $success_page = $failed_page = $submit = $recurring_plan = '';
$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

global $gather_stripe_options;

$eventres_terms_content         = get_option('eventres_terms_content' );
$eventres_hide_terms            = get_option('eventres_hide_terms' );

if(isset($gather_stripe_options['stripe_test_mode']) && $gather_stripe_options['stripe_test_mode']) {
    $publishable_key = $gather_stripe_options['test_publishable_key'];
} else {
    $publishable_key = $gather_stripe_options['live_publishable_key'];
}

// new in version 2
$eventres_add_fields = array();
if(isset($gather_stripe_options['add_fields'])) { 
    $eventres_add_fields = $gather_stripe_options['add_fields'];
}

$ajax_datas = array(
    'url'           => admin_url( 'admin-ajax.php' ),
    'msg_fname'     => get_option('eventres_message_empty_fname' ),
    'msg_lname'     => get_option('eventres_message_empty_lname' ),
    'msg_email'     => get_option('eventres_message_empty_email' ),
    'msg_pass'     => get_option('eventres_message_empty_pass' ),
    'msg_seats'     => get_option('eventres_message_empty_seats' ),
    'msg_agree'     => get_option('eventres_message_empty_agree' ),
    'msg_wait'     => __('Please wait...','cth-gather-plugins'),

    'stripe_publishable_key' =>  $publishable_key,
);
if(!empty($eventres_add_fields)){
    $ajax_datas['add_fields_validate'] = array();
    foreach ($eventres_add_fields as $key => $add_field) {
        $field_name = str_replace(array(" ","-"), "_", $add_field['name']);
        // echo'<pre>';var_dump($add_field['required']);
        if(isset($add_field['required'])&& $add_field['required'] == 'true'){
            $ajax_datas['add_fields_validate'][$field_name] = "required";
        }
        
    }
}

wp_enqueue_script( 'stripeapi', 'https://js.stripe.com/v3/', array(), null, false );


wp_enqueue_script("eventstriperes-js", CTH_EVENTRES_DIR_URL . "assets/js/eventstriperes.js", array('jquery','gather-validate-js'), null, true);
//Main Ajax script 
wp_localize_script( 'eventstriperes-js', 'eventres_ajax', $ajax_datas );
?>

<div class="registration-form <?php echo esc_attr($el_class );?>">
    <h4 class="modal-title text-center" id="register-now-label"><?php echo esc_attr($form_title );?></h4>

    <?php if(!empty($content)){
        echo wpb_js_remove_wpautop($content);
    }?>
    <form action="<?php //echo get_permalink( );?>" method="POST" target="_top" class="stripe-reg-form" id="stripe-regn">
        
        <div id="eventreg_msg"></div>
        
        <div class="row">
            <div class="col-sm-6">
                <div class="form-group">
                    <label><?php _e('First Name','cth-gather-plugins');?></label>
                    <input type="text" class="form-control" name="first_name" placeholder="<?php _e('First Name','cth-gather-plugins');?>" required>
                </div>
            </div>
            <div class="col-sm-6">
                <div class="form-group">
                    <label><?php _e('Last Name','cth-gather-plugins');?></label>
                    <input type="text" class="form-control" name="last_name" placeholder="<?php _e('Last Name','cth-gather-plugins');?>" required>
                </div>
            </div>
        </div>
        <div class="form-group">
            <label><?php _e('Email Address','cth-gather-plugins');?></label>
            <input type="email" class="form-control" name="email" placeholder="<?php _e('Email Address','cth-gather-plugins');?>" required>
            <!-- <p><?php _e('Payment receipt emails will be sent to this email address','cth-gather-plugins') ;?></p> -->
        </div>

        <?php if(!empty($eventres_add_fields)){
            foreach ($eventres_add_fields as $key => $add_field) {
                ?>
                <div class="form-group">
                    
                <?php if($add_field['type'] == 'text'):?>
                    <label><?php echo $add_field['label'];?></label>
                    <input type="text" class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>" value="<?php echo $add_field['value'];?>" placeholder="<?php echo $add_field['label'];?>">
                <?php elseif($add_field['type'] =='textarea'):?>
                    <label><?php echo $add_field['label'];?></label>
                    <textarea class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>" placeholder="<?php echo $add_field['label'];?>"><?php echo $add_field['value'];?></textarea>
                <?php elseif($add_field['type'] =='select'&&!empty($add_field['value'])):?>
                    <label><?php echo $add_field['label'];?></label>
                    <select class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>">
                        <?php foreach ($add_field['value'] as $key => $f_ops) {
                            echo '<option value="'.esc_attr($f_ops['value'] ).'">'.esc_attr($f_ops['name'] ).'</option>';
                        } ?>
                    </select>
                <?php endif;?>
                </div>
        <?php
            }
        } ?>

        <?php 
        if($recurring_plan == 'no') : ?>

        <div class="row form-group">
            <div class="col-sm-7">
                <div class="form-group">
                    <label><?php echo __('Choose a ','cth-gather-plugins') . esc_attr($gather_stripe_options['prices_label'] );?></label>
                    <?php if( isset( $gather_stripe_options['prices'] ) && count( $gather_stripe_options['prices'] )): ?>
                    <select class="form-control" name="os0" required>
                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                    <?php foreach ( $gather_stripe_options['prices'] as $value) { ?>
                        <option value="<?php echo esc_attr($value['name'] );?>"><?php echo esc_attr($value['name'] ) .' - '. esc_attr($value['value'] ).' '.esc_attr( $gather_stripe_options['currency'] );?></option>
                    <?php } ?>
                    </select>
                    <?php else :?>
                    <select class="form-control" name="os0" required>
                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                        <option value="Default Pass">Default Pass - 99 USD</option>
                    </select>
                    <?php endif;?>
                </div>
                
            </div>
            
            <div class="col-sm-5">
                <div class="form-group">
                    <label><?php echo esc_attr( $gather_stripe_options['quantity_label'] );?></label>
                    <?php if( isset( $gather_stripe_options['quantities'] ) && count( $gather_stripe_options['quantities'] )): ?>
                    <select class="form-control" name="item_quantity" required>
                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                    <?php foreach ( $gather_stripe_options['quantities'] as $value) { ?>
                        <option value="<?php echo esc_attr($value['value'] );?>"><?php echo esc_attr($value['name'] );?></option>
                    <?php } ?>
                    </select>
                    <?php else : ?>
                    <input type="text" name="item_quantity" class="form-control" value="1">
                    <?php endif;?>
                </div>
            </div>
        </div>

        <?php else: ?>
            <?php 
            if(isset( $gather_stripe_options['stripe_plans'] ) && !empty( $gather_stripe_options['stripe_plans'] )) : ?>
                <div class="form-group">
                    <label><?php _e('Select a plan','cth-gather-plugins');?></label>
                    
                    <select class="form-control" name="stripe_plan" required>
                    <?php foreach ( $gather_stripe_options['stripe_plans'] as $value) { ?>
                        <option value="<?php echo base64_encode( $value['value'] );?>"><?php echo esc_attr($value['name'] );?></option>
                    <?php } ?>
                    </select>
                </div>

                <div class="form-group">
                    <label><?php echo esc_attr( $gather_stripe_options['quantity_label'] );?></label>
                    <?php if( isset( $gather_stripe_options['quantities'] ) && count( $gather_stripe_options['quantities'] )): ?>
                    <select class="form-control" name="item_quantity" required>
                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                    <?php foreach ( $gather_stripe_options['quantities'] as $value) { ?>
                        <option value="<?php echo esc_attr($value['value'] );?>"><?php echo esc_attr($value['name'] );?></option>
                    <?php } ?>
                    </select>
                    <?php else : ?>
                    <input type="text" name="item_quantity" class="form-control" value="1">
                    <?php endif;?>
                </div>

            <?php endif;?>
        <?php endif;?>

        <?php if( isset( $gather_stripe_options['use_coupon'] ) && $gather_stripe_options['use_coupon']  == 'yes' ) :?>
        <div class="row form-group use_coupon_row">
            <div class="col-sm-12">
                <div class="form-group">
                    <?php if(isset($gather_stripe_options['coupon_message'])) echo wp_kses_post( $gather_stripe_options['coupon_message'] );?>
                    <input type="text" class="form-control" id="coupon_code" name="coupon_code" placeholder="<?php _e('Coupon Code','cth-gather-plugins');?>">
                </div>
            </div>
        </div>
        <?php endif;?>

        <div class="form-group">
            <label><?php _e('Card','cth-gather-plugins');?></label>
            <div id="stripe-modal-card-element" class="field is-empty stripe-card-field"></div>
        </div>
        <div class="form-group">
            <div class="checkbox">
                <label>
                <?php if($gather_stripe_options['hide_terms'] == 'yes') :?>
                    <input checked="checked" type="checkbox" name="agree" required style="display:none;">
                <?php else :?>
                    <input type="checkbox" name="agree" required>
                <?php endif;?>
                    <?php echo wp_kses_post( $gather_stripe_options['terms_content'] );?>
                </label>
            </div>
        </div>

        <input type="hidden" name="action" value="gather_event_stripe"/>
        <?php 
        if($success_page != '') : ?>
        <input type="hidden" name="success_redirect" value="<?php echo esc_url($success_page ); ?>"/>
        <?php 
        endif ; ?>
        <?php 
        if($failed_page != '') : ?>
        <input type="hidden" name="failed_redirect" value="<?php echo esc_url($failed_page ); ?>"/>
        <?php 
        endif ; ?>
        <input type="hidden" name="stripe_nonce" value="<?php echo wp_create_nonce('gather_event_stripe_action'); ?>"/>
        
        <div class="text-center top-space">
            <button type="submit" id="reserve-btn" class="btn btn-success btn-lg"><?php echo esc_attr($submit );?></button>
            
        </div>
    </form>

</div>


